LibreOffice: Package Service Reference

LibreOffice LibreOffice 6.0 SDK API Reference

Exported Interfaces | List of all members
Package Service Referencepublished

The Package is a service that provides access to a set of files and folders contained within a Package. More...

`import"Package.idl";`

Inheritance diagram for Package:

## Exported Interfaces
interface | com::sun::star::lang::XInitialization
| A Package can be initialized with one of the following: More...
interface | com::sun::star::container::XHierarchicalNameAccess
| This interface is used to get access to any entry within the package For example: getByHierarchicalName ("folder/subfolder/file1.txt"); This will return a PackageStream which refers to the specified stream. More...
interface | com::sun::star::lang::XSingleServiceFactory
| This interface is used to create new PackageStream or PackageFolder implementation objects for addition to the Package. More...
interface | com::sun::star::util::XChangesBatch
| This interface is used to commit any changes to the Package. More...

## Additional Inherited Members
Public Member Functions inherited from XInitialization
void | initialize ([in] sequence< any > aArguments) raises ( com::sun::star::uno::Exception )
| initializes the object. More...
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...
Public Member Functions inherited from XHierarchicalNameAccess
any | getByHierarchicalName ([in] string aName) raises ( com::sun::star::container::NoSuchElementException )
boolean | hasByHierarchicalName ([in] string aName)
Public Member Functions inherited from XSingleServiceFactory
com::sun::star::uno::XInterface | createInstance () raises ( com::sun::star::uno::Exception )
| Creates an instance of a service implementation. More...
com::sun::star::uno::XInterface | createInstanceWithArguments ([in] sequence< any > aArguments) raises ( com::sun::star::uno::Exception )
| Creates an instance of a service implementation initialized with some arguments. More...
Public Member Functions inherited from XChangesBatch
void | commitChanges () raises ( com::sun::star::lang::WrappedTargetException )
| commits any pending changes. More...
boolean | hasPendingChanges ()
| checks whether this object has any pending changes that can be committed. More...
ChangesSet | getPendingChanges ()
| queries for any pending changes that can be committed. More...

## Detailed Description

The Package is a service that provides access to a set of files and folders contained within a Package.

One instance of the Package service exists for each Package file to be manipulated.

Each instance is created with an argument which specifies the URL of the Package file to which the user requires access. If the instance is created without arguments, it must be initialized with the com::sun::star::lang::XInitialization service methods before it is a valid instance of the service.

## Exported Interfaces

## ◆ com::sun::star::container::XHierarchicalNameAccess

interface com::sun::star::container::XHierarchicalNameAccess

This interface is used to get access to any entry within the package For example: getByHierarchicalName ("folder/subfolder/file1.txt"); This will return a PackageStream which refers to the specified stream.

This is also used to get access to a particular folder within the Package. For example: getByHierarchicalName ("folder/subfolder/"); This will return a PackageFolder which describes the contents of the specified folder.

Calls to methods of XHierarchicalNameAccess must NOT have a leading slash.

## ◆ com::sun::star::lang::XInitialization

interface com::sun::star::lang::XInitialization

A Package can be initialized with one of the following:

1. A file URL referring to a package.
2. An XInputStream referring to a package (it must also support an XSeekable interface).
3. An XStream referring to a package. The XInputStream must support an XSeekable interface, and the XOutputStream must support an XTruncate interface.

It will throw a css::uno::Exception if initialized with bad data or if the package has an invalid format (for example, a corrupt central directory record if the file is a ZIP file).

## ◆ com::sun::star::lang::XSingleServiceFactory

interface com::sun::star::lang::XSingleServiceFactory

This interface is used to create new PackageStream or PackageFolder implementation objects for addition to the Package.

createInstance - creates a new stream implementation object (when first created, the new object is not part of the Package). It must be added to the PackageFolder in which it will reside using the methods in the PackageFolder service.

createInstanceWithArguments - This accepts one boolean value as an argument. If it set to true, a PackageFolder implementation is created, if it is set to false, a PackageStream implementation is created.

Creating and inserting a new stream would be done as follows:

    1. xNewStream = package->createInstanceWithArguments( false );
    2. xDataStream = new MyStreamImpl(). (wherever the data comes from)
    3. xNewStream->setInputStream( xDataStream );
    4. parentFolder->insertByName( "image.png", xNewStream );

Replacing an existing stream would be very similar, except that the call ->insertByName would be replaced by ->replaceByName.

## ◆ com::sun::star::util::XChangesBatch

interface com::sun::star::util::XChangesBatch

This interface is used to commit any changes to the Package.

A new Package file will be written with any new or changed streams/folders and omitting any PackageStream or PackageFolder that has been removed.

The documentation for this service was generated from the following file:

- com/sun/star/packages/Package.idl